//----------------------------------------------------------------------//
// umF_CAO													//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include <algorithm>
#include "UserFunc.h"
#include "Global.h"
#include "AskRep.h"

//---------------------------------------------------------------------
#pragma resource "*.dfm"
TAskRepDlg *AskRepDlg = NULL;

//---------------------------------------------------------------------
__fastcall TAskRepDlg::TAskRepDlg(TComponent* AOwner)
	: TForm(AOwner)
{
	FoundPos = FoundLine = 0;
	CurIndex = -1;
}
//---------------------------------------------------------------------------
void __fastcall TAskRepDlg::FormCreate(TObject *Sender)
{
	org_SttBar1WndProc	   = StatusBar1->WindowProc;
	StatusBar1->WindowProc = SttBar1WndProc;

	ListScrPanel = new UsrScrollPanel(ListPanel, RepListBox, USCRPNL_FLAG_P_WP | USCRPNL_FLAG_L_WP);
}
//---------------------------------------------------------------------
void __fastcall TAskRepDlg::FormShow(TObject *Sender)
{
	IniFile->LoadPosInfo(this, DialogCenter);

	RepListBox->Font->Assign(GrepResFont);
	RepListBox->Color = col_bgList;
	set_ListBoxItemHi(RepListBox);
	set_UsrScrPanel(ListScrPanel);
	ListScrPanel->UpdateKnob();

	StatusBar1->Font->Assign(ViewHdrFont);
	StatusBar1->ClientHeight = get_FontHeight(ViewHdrFont, 4, 4);
	StatusBar1->Panels->Items[0]->Text = yen_to_slash(FileName);
	StatusBar1->Panels->Items[1]->Text = UnicodeString().sprintf(_T(" File %u/%u"), FileIndex + 1, FileCount);
}
//---------------------------------------------------------------------------
void __fastcall TAskRepDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	IniFile->SavePosInfo(this);
}
//---------------------------------------------------------------------------
void __fastcall TAskRepDlg::FormDestroy(TObject *Sender)
{
	delete ListScrPanel;
}

//---------------------------------------------------------------------------
void __fastcall TAskRepDlg::FormResize(TObject *Sender)
{
	StatusBar1->Panels->Items[0]->Width = ClientWidth - ScaledInt(120);
}

//---------------------------------------------------------------------------
void __fastcall TAskRepDlg::SttBar1WndProc(TMessage &msg)
{
	if (msg.Msg==WM_ERASEBKGND && draw_InfHdrBg(StatusBar1, msg)) return;

	org_SttBar1WndProc(msg);
}
//---------------------------------------------------------------------------
void __fastcall TAskRepDlg::StatusBar1DrawPanel(TStatusBar *StatusBar, TStatusPanel *Panel,
          const TRect &Rect)
{
	TCanvas *cv = StatusBar->Canvas;
	cv->Font->Assign(StatusBar->Font);
	cv->Brush->Color = col_bgInfHdr;
	cv->FillRect(Rect);
	cv->Font->Color  = col_fgInfHdr;
	cv->TextOut(Rect.Left + 2, Rect.Top, Panel->Text);
}

//---------------------------------------------------------------------------
void __fastcall TAskRepDlg::RepListBoxDrawItem(TWinControl *Control,
		int Index, TRect &Rect, TOwnerDrawState State)
{
	TListBox *lp = (TListBox*)Control;
	TCanvas  *cv = lp->Canvas;
	cv->Font->Assign(lp->Font);
	cv->Brush->Color = col_bgList;
	cv->FillRect(Rect);

	UnicodeString itmstr = lp->Items->Strings[Index];
	int xp = Rect.Left + 2;
	int yp = Rect.Top + get_TopMargin(cv);

	//sԍ
	TRect rc = Rect;
	LineNoOut(cv, rc, FoundLine - CurIndex + Index);
	cv->Brush->Color = col_bgList;
	xp = rc.Left + 4;

	//}b`s
	if (Index==CurIndex) {
		cv->Font->Color = col_fgList;
		if (FoundPos>0) {
			//}b`O
			TabCrTextOut(itmstr.SubString(1, FoundPos - 1), cv, xp, yp, col_fgList, Rect.Right);
			itmstr.Delete(1, FoundPos - 1);
			//}b`ꋭ\
			EmphasisTextOut(itmstr, KeyWord, cv, xp, yp, false, true);
		}
		else TabCrTextOut(itmstr, cv, xp, yp, col_fgList, Rect.Right);

		//J[\
		int lw = std::max(CursorWidth, 1);
		int yp = Rect.Bottom - lw;
		draw_Line(cv, Rect.Left, yp, Rect.Right, yp, lw, col_Cursor);
	}
	//Os
	else TabCrTextOut(itmstr, cv, xp, yp, col_fgList, Rect.Right);
}

//---------------------------------------------------------------------------
void __fastcall TAskRepDlg::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	SpecialKeyProc(this, Key, Shift);
}
//---------------------------------------------------------------------------

